/*

#
#	ScanBase ver 1.0
#	By DrEaMaN BlahCorp 2000.
#	=========================
#
#	ScanBase was built for people who don't know how to
#	write a fully working scanner but only the scanning function.
#
#	The idea behide this is to bring more people to build scanners
#	even if they don't have the basic knowlage of making one, or just
#	want a premade basic scanning code with most common options.
#
#	Greets goes to: moca,Mebel.
#
#	Contact me by E-Mail: Dre@BlahCorp.Org or IRC: at Efnet DrEaMaN.
#	Released on: 02/03/01.
#

*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define RAND_MAX 25

char ipA[15]="";
char ipB[15]="";
int childs=0,max_childs=0;
FILE *ips_file;
char IPS_FILE[30];

void usage(void) 
{
        printf("\n\t\e[1m(( Options ))\e[0;0m\n");
        printf("-f <filename>\t - scans a file\n");
        printf("-c <childs>\t - scans with 100 childs\n");
        printf("-o <host>\t - scans a host\n");
	printf("-b <ip>\t\t - begin at ip\n");
	printf("-e <ip>\t\t - end at ip\n");
	printf("-z <domain>\t - gets ips with z0ne\n");
	printf("-h <domain>\t - gets ips with host\n");
        printf("\n\e[1mExamples:\e[0;0m\n");
        printf("./scanner -f ips -c 20 > result\n");
        printf("./scanner -o www.microsoft.com\n");
	printf("./scanner -b 127.0.0.1 -e 127.0.0.10 -c 10 > result\n");
	printf("./scanner -z bla.net -c 20 > result\n");
	exit(0);
}

void MassScan()
{
	char tmp[128];
	int err;
	long pid;

	rewind(ips_file);
	while ((fgets(tmp,128,ips_file)) != NULL) 
	{
		if (!(err=fork())) 
		{
			pid = getpid();
			Scan(tmp);
			childs--;
			exit(0);
		}
		else
		{
			childs++;
			if (childs>max_childs)
				wait(&pid);
		}
	}
}
void open_ips_file(char *method)
{

	if ((ips_file = fopen(IPS_FILE,method)) == NULL)
	{
		perror("fopen");
		exit(1);
	}
	printf("Using %s for getting ips\n",IPS_FILE);
}
void generate_ips_file()
{
	srand(time(0));
	sprintf(IPS_FILE,".sb%ld",rand()); 
}
void count_ips(void)
{
	long i;
	char tmp[128];

	i = 0;
	while (fgets(tmp,128,ips_file) != NULL) { i++; }
	fprintf(stderr,"Found %ld ips.\n",i); fflush(stdout);
}
void collect_host(char *domain)
{
	long i;
	FILE *host;
	char tmp[128],cmd[110],tmp2[128];
	int m;

	i = 0;
	printf("Collecting ips using host.."); fflush(stdout);
	strcpy(cmd,"host -l ");
	strcat(cmd,domain);
	if ((host = popen(cmd,"r")) == NULL)
	{
		perror("popen");
		exit(1);
	}
	while ((fgets(tmp,128,host)) != NULL)
	{
		if (!(isdigit(tmp[strlen(tmp)-2])) == 0) 
		{
			strcpy(tmp,strrchr(tmp,' '));
			strcpy(&tmp[0],&tmp[1]);
			tmp[strlen(tmp)-1] = '\0';
			rewind(ips_file);
			m = 0;
			while ((fgets(tmp2,128,ips_file)) != NULL)
				if (strstr(tmp,tmp2) == 0)
				{
					m = 1;
					fseek(ips_file,0L,SEEK_END);
				}			
			fseek(ips_file,0L,SEEK_END);
			if (((m == 0)) && ((!(strcmp(tmp,"127.0.0.1") == 0)))) 
			{ 
				fprintf(ips_file,"%s\n",tmp); 
				i++; 
			}

		}
	}
	pclose(host);
	fclose(ips_file);
	if ((ips_file = fopen(IPS_FILE,"r")) == NULL)
	{
		perror("fopen");
		exit(1);
	}
	printf("Found %ld ips.\n",i); fflush(stdout);
}
void collect_zone(char *domain) 
{
	char cmd[110];

	printf("Collecting ips using z0ne.."); fflush(stdout);
	sprintf(cmd,"./z0ne -o %s > %s",domain,IPS_FILE);
	system(cmd);
}                   
void generate_ips(void) 
{
	int IP[8];
	int i,m,j,z;
	char tmp[3];

	i = 0; m = 0;
	tmp[0] = '\0';

	for (i=0; i < strlen(ipA); i++) 
	{
		if (ipA[i] != '.')
			sprintf(tmp,"%s%c",tmp,ipA[i]);
		else
		{
			IP[m] = atoi(tmp);
			tmp[0] = '\0';	m++;
		}
	}

	IP[3] = atoi(strdup(tmp));
	tmp[0] = '\0'; m++; 
	for (i=0; i < strlen(ipB); i++)
        {
                if (ipB[i] != '.')
                        sprintf(tmp,"%s%c",tmp,ipB[i]);
                else
                {
                        IP[m] = atoi(tmp);
			tmp[0] = '\0'; m++;
                }
        }
        IP[7] = atoi(tmp);   

	for (i=0; i<4; i++) 
		if (((IP[i] < 0)) || ((IP[i] > 255))) exit(0);

	printf("Generating ips %d.%d.%d.%d-%d.%d.%d.%d\n",
				IP[0],IP[1],IP[2],IP[3],
				IP[4],IP[5],IP[6],IP[7]);

	while (	(IP[0]<=IP[4]) && (IP[1]<=IP[5]) &&
		(IP[2]<=IP[6]) && (IP[3]<=IP[7])  )
	{

		fprintf(ips_file,"%d.%d.%d.%d\n",IP[0],IP[1],IP[2],IP[3]);

        	if (IP[2] == 255) { IP[3] = 1; IP[2]++; } else { IP[3]++; }
        	if (IP[1] == 255) { IP[2] = 0; IP[1]++; }
        	if (IP[0] == 255) { IP[1] = 0; IP[0]++; } 
	}

}


int main (int argc, char *argv[]) {

	int i,err;
	char *file,zone[100]="",host[100]="",tmp[128],ch,single[128]="";
	long pid;
	err = 0;

	print_logo();
	printf("\nBuilt with ScanBase ver 1.0 (Yedidya) by DrEaMaN\n");
	if (argc == 1) usage();
	while((ch = getopt(argc, argv, "f:o:c:b:e:z:h:")) != EOF) 
		switch(ch) 
		{
			case 'f': strcpy(IPS_FILE,optarg); err++; break;
			case 'o': strcpy(single,optarg); break;
			case 'c': max_childs = atoi(optarg); break;
			case 'b': strcpy(ipA,optarg); break;
			case 'e': strcpy(ipB,optarg); break;
			case 'z': strcpy(zone,optarg); err++; break;
			case 'h': strcpy(host,optarg); err++;
		}
	if (err > 1) { 
		printf("\Error: more then one method of scanning was chosen.");
		exit(0); 
	} 

	if ( (((strlen(IPS_FILE) != 0)) || 
			((strlen(zone) != 0)) || 
		  	((strlen(host) != 0 ))	
		) &&	((!(max_childs > 0))) )
	{
        	printf("Error: number of childs wasn't set.\n"); 
		exit(0); 
	}   
	if (((strcmp(ipA,ipB) == 0)) && ((!(ipA[0] == '\0')))) { 
		printf("Error: begin ip can't be same as end ip.\n");
		exit(0);
	}

	if (strlen(IPS_FILE) != 0)
	{
		open_ips_file("r");
	}
	if (strlen(zone) != 0) 
	{
		generate_ips_file();
		collect_zone(zone);
		open_ips_file("r");
		count_ips();
	}
	if (strlen(host) != 0)
	{
		generate_ips_file();
		open_ips_file("w");
		collect_host(host);
	}
	if (strlen(ipA) != 0)
	{
		generate_ips_file();
		open_ips_file("w+");
		generate_ips();
	}
	if (strlen(single) != 0) 
	{
		Scan(single);
		exit(0);
	}
	
	MassScan();
	fclose(ips_file);
}
